/* FireTracker
   By: Francisco Dias - XicoMBD
   7 December 2010
*/

import lll.wrj4P5.*;
import lll.Loc.*;
import processing.serial.*;
import controlP5.*;

Wrj4P5 wii;
Serial TheBox;
ControlP5 controlP5;
Textfield myTextfield;

float x;
float y;
float w;
float h;

int camWidth = 512; 
int camHeight = 384;

int xmin = camWidth/3;
int xmax = camWidth-camWidth/3;

String COMPort = "";

int sd=0;
int wd=0;
int dd=0;


void setup() {
  size(camWidth,camHeight+100);
  wii=new Wrj4P5(this).connect(Wrj4P5.IR);

 controlP5 = new ControlP5(this);

  controlP5.addTextfield("COMPort",(camWidth/2)-50,450,100,20);

  controlP5.addSlider("xmin",0,camWidth,xmin,0,camHeight,camWidth,5);
  controlP5.addSlider("xmax",0,camWidth,xmax,0,camHeight+5,camWidth,5);

} 

void draw() {
  background(0);
  stroke(255);     
  line(0,camHeight,camWidth,camHeight);

  if (sd==0){
  text("Please define your COM port",camWidth/2-75,camHeight+50);
   String[] m1 = match(COMPort, "COM");
    if (m1 != null) {
      // This will print to the console.
     TheBox = new Serial(this,COMPort,4800);
       TheBox.write('g'); 
     sd=1;
     println(COMPort);
     size(camWidth,camHeight+60);
    }  
   } 
  
  if (wd==0){
   text("Please press 1&2 Buttons on your Wiimote",camWidth/2-115,camHeight/2);
   } 

  //  if (wii.isConnecting()) return;

  stroke(0,0,255);
    line(xmin,0,xmin,camHeight); 
    line(xmax,0,xmax,camHeight); 

  
//
  for (int i=0;i<4;i++) {
    Loc p=wii.rimokon.irLights[i];
    if (p.x>-1) {
       x=((p.x)*camWidth);
       print(x);
       print(" ");
       y=((1.-p.y)*camHeight);
       print(y);
       print(" ");
       w=p.z*50;
       print(w);
       print(" ");
       h=p.z*100;
       println(h);

       noStroke();
       fill(255,255,0);
       ellipse(x, y, w, h);

       stroke(255);
       line(x,0,x,camHeight);
       line(0,y,camWidth, y);
       
       delay(50);
       dd=1;
       wd=1;
    }
  }
  
 if (sd==1 && wd==1){
  fill(255);
  text("Commands being sent:",camWidth/2-65,camHeight+30);
 
 if (dd==1){ 
  if(x>xmin && x<xmax){
   TheBox.write('w');
   println("w - Go Foward");
   text("w - Go Foward",camWidth/2-35,camHeight+50);
  }
 if(x>xmax){
   TheBox.write('w');
   TheBox.write('a');
   println("a - Turn Right");
   text("a - Turn Right",camWidth/2-35,camHeight+50);
  }
 if(x<xmin){
   TheBox.write('w');
   TheBox.write('d');
   println("d - Turn Left");
   text("d - Turn Left",camWidth/2-30,camHeight+50);
  }
 }

if (dd == 0){
  TheBox.write('g'); 
  println("g - Stop");
  text("g - Stop",camWidth/2-20,camHeight+50);
}

delay(50);
  dd=0; 
} 
  
}
